;ZwHooks 
;
; Hook NtQuerySystemInformation
;       - when there is enumeration of all loaded modules (drivers in this case)
;         softice can be detected.
;       - hook simply calls NtQuerySystemInformation and then scans data passed
;         back and changes names of sice drivers to sometething else
;
; Hook NtQueryObject
;       - debugger can be detected runnin' in your system if ObjectAllTypes class
;         is used with NtQueryObject
;       - When Debugger is present DebugObject will have opened handles and also
;         object count would be non-0. If debugger is present both fields of OBJECT_TYPE_INFORMATION
;         will hold some other value (non zero). Very scary check because there are 
;         some protections that use Win32Dbg subsystem to debug them selves such as
;         Armadillo and SafeDisc. Very anoying stuff for legitimate users and also 
;         for me with Reged GetRight...!!!!
;       - hook will scan for DebugObject and set ObjectCount and ObjectHandle to 0 and
;         such stupid protectors will simply make my life easier...
;         
;                                               S verom u Boga, deroko/ARTeam
;


                        .586p
                        .model  flat, stdcall
                        locals
                        jumps

include                 c:\tasm32\include\shitheap.inc
include                 c:\tasm32\include\ring0extern.inc
include                 ring0.inc
     
                        .data
driver:                 unis    <\Device\hookzw>
symlink:                unis    <\??\hookzw>
driver_us               unicode_string <0>
sym_us                  unicode_string <0>
pdeviceobject           dd      ?
mdlh                    dd      ? 

                        ;.code
                        public  C start
                        
start:                  ;[ebp+8] pDriverObject [ebp+0ch] pRegPatch
                        push    ebp
                        mov     ebp, esp
                        pusha
                        
                        call    RtlInitUnicodeString, offset driver_us, offset driver
                        call    IoCreateDevice, dword ptr[ebp+8], 0, offset driver_us, FILE_DEVICE_UNKNOWN, 0, 0, offset pdeviceobject
                        test    eax, eax
                        jnz     __failinit

                        call    RtlInitUnicodeString, offset sym_us, offset symlink
                        call    IoCreateSymbolicLink, offset sym_us, offset driver_us
                        test    eax, eax
                        jnz     __deletedevice
                        
                        mov     eax, [ebp+8]                    ;pDriverObject

                        mov     [eax.dro_majorfunctions.irp_mj_create], offset RequestHandler     
                        mov     [eax.dro_majorfunctions.irp_mj_close], offset RequestHandler     
                        mov     [eax.dro_majorfunctions.irp_mj_device_control], offset ServiceHandler     
                        mov     [eax.dro_DriverUnload], offset DriverUnload                              
                                                
                        xor     eax, eax
                        jmp     __exitinit                        
                        
__deletedevice:         call    IoDeleteDevice, pdeviceobject
                             
                        
__failinit:             mov     eax, 1
                        
__exitinit:             mov     [esp.Pushad_eax], eax
                        popa
                        pop     ebp
                        retn    8
                        
RequestHandler:         ;[esp+4] pDeviceObject, [esp+8] pIrp
                        mov     ecx, [esp+8]
                        mov     [ecx.irp_iostatus.iob_status], 0
                        mov     [ecx.irp_iostatus.iob_information], 0
                        xor     edx, edx
                        call    IofCompleteRequest
                        xor     eax, eax
                        retn    8

DriverUnload:           ;pDriverObject  [esp+4]                        
                        call    IoDeleteSymbolicLink, offset sym_us

                        mov     eax, [esp+4]
                        call    IoDeleteDevice, [eax.dro_deviceobject]
                        retn    4

ServiceHandler:         ;[ebp+8] pDeviceObject, [ebp+0ch] pIrp
                        push    ebp
                        mov     ebp, esp
                        pusha
                        
                        mov     ebx, [ebp+0ch]  ;pIrp
                        mov     edx, [ebx.irp_tail.t_CurrentStackLocation]  
                        
                        cmp     [edx.isl_IoControlCode], 10h
                        jne     __sh_fail

                        mov     ebx, [ebx.irp_systembuffer]
                        
                        cmp     [ebx], 'HOOK'
                        jne     __sh_fail
                                                
                        call    ExAllocatePool, 0, hook_size
                        test    eax, eax
                        jz      __sh_fail
                        
                        mov     edi, eax

                        mov     esi, KeServiceDescriptorTable
                        mov     eax, [ebx+4]
                        mov     servicenumber_smi, eax      
                        mov     esi, [esi]                       
                
                        mov     ebx, [esi+eax*4]                
                        mov     old_NtQuerySystemInformation, ebx
                        mov     eax, ZwQueryObject
                        mov     eax, [eax+1]
                        mov     servicenumber_zwo, eax
                        mov     ebx, [esi+eax*4]
                        mov     old_NtQueryObject, ebx
                        
                        
                        push    esi
                        push    edi
                        mov     esi, offset hook_start
                        mov     ecx, hook_size
                        cld
                        rep     movsb
                        pop     edi
                        pop     esi
                        
                        cli
                        mov     edx, cr0
                        and     edx, 0FFFeFFFFh
                        mov     cr0, edx
                        
                        mov     eax, servicenumber_smi
                        mov     [esi+eax*4], edi
                        
                        add     edi, New_NtQueryObject - New_NtQuerySystemInformation
                        mov     eax, servicenumber_zwo
                        mov     [esi+eax*4], edi
                        
                        or      edx, 10000h
                        mov     cr0, edx
                        sti
                                                                                               
__sh_oki:               mov     ecx, [ebp+0ch]
                        xor     edx, edx
                        call    IofCompleteRequest
                        xor     eax, eax
                        jmp     __sh_exit
                        
__sh_fail:              mov     ecx, [ebp+0ch]
                        xor     edx, edx
                        call    IofCompleteRequest                       
                        mov     eax, 1            
                                    
__sh_exit:              mov     [esp.Pushad_eax], eax
                        popa
                        pop     ebp
                        retn    8                        

servicenumber_smi       dd      ?
servicenumber_zwo       dd      ?
hook_start:
New_NtQuerySystemInformation    proc
                        arg     systeminformationclass
                        arg     systeminformation
                        arg     systeminformationsize
                        arg     requiredsize
                                            
                        push    requiredsize
                        push    systeminformationsize
                        push    systeminformation
                        push    systeminformationclass
                        call    __delta
__delta:                pop     eax
                        sub     eax, offset __delta
                        call    dword ptr[eax + old_NtQuerySystemInformation]
                        test    eax, eax
                        jnz     __error
                        
                        cmp     systeminformationclass, 0bh
                        jne     __error
                        
                        pusha
                        mov     esi, systeminformation
                        mov     ecx, [esi]
                        add     esi, 4
                        
__cycle_modules:        lea     ebx, [esi.smi_imagename]
                        movzx   eax, [esi.smi_modulenameoffset]
                        add     ebx, eax
                        cmp     [ebx], 'ciTN'
                        je      __change
                        cmp     [ebx], 'DisO'
                        je      __change
                        cmp     [ebx], 'vwis'
                        je      __change
                        cmp     [ebx], 'htpc'
                        jne     __next_module

__change:               mov     [ebx], 'ison'
                        
__next_module:
                        add     esi, size system_module_information                       
                        loop    __cycle_modules
                        
                        popa
__error:                leave
                        retn    10h  
old_NtQuerySystemInformation    dd      ?
                        endp

New_NtQueryObject       proc
                        arg     ob_handle
                        arg     ob_information_class
                        arg     ob_information_buf
                        arg     ob_information_len
                        arg     ob_reqsize
                        local   zw_delta:dword
                        call    __zw_delta
__zw_delta:             pop     eax
                        sub     eax, offset __zw_delta
                        mov     zw_delta, eax
                        
                        push    ob_reqsize
                        push    ob_information_len
                        push    ob_information_buf
                        push    ob_information_class
                        push    ob_handle
                        call    dword ptr [eax + old_NtQueryObject]                        
                        test    eax, eax
                        jnz     __zw_exit
                        cmp     ob_information_class, 3
                        jne     __zw_exit
                        
                        cld                     ;just to be sure that D flag isn't set
                        pusha
                        mov     ebx, zw_delta
                        mov     esi, ob_information_buf
                        mov     ecx, [esi]
                        add     esi, 4
                        
__cycle_object:         lea     edi, [ebx+bad_object]
                        push    esi ecx
                        movzx   ecx, [esi.oti_name.us_len]
                        mov     esi, [esi.oti_name.us_buff]
                        repe    cmpsb
                        pop     ecx esi
                        jz      __found_d_object
                        
                        mov     eax, [esi.oti_name.us_buff]
                        movzx   edx, [esi.oti_name.us_maxlen]
                        add     edx, eax
                        mov     al, dl
                        and     al, 3
                        jz      __no_align
                        and     dl, 0fch
                        add     edx, 4
__no_align:             mov     esi, edx
                        loop    __cycle_object
                        jmp     __zw_e_popa
                        
__found_d_object:       xor     eax, eax
                        mov     [esi.oti_ObjectCount], eax
                        mov     [esi.oti_HandleCount], eax
__zw_e_popa:            popa
__zw_exit:              leave
                        retn    14h
                        endp
old_NtQueryObject       dd      ?
bad_object:             unis    <DebugObject>           
hook_size               =       $-hook_start                   
end                     start



